      SUBROUTINE ZP16D(A,NREAL,ROOT,IERR)
         INTEGER IERR,NREAL
         DOUBLE PRECISION A,ROOT
         DIMENSION A(4),ROOT(3)
         EXTERNAL UTZP11
         DOUBLE PRECISION P,R1,R2,SYS007,X,Y,Z
         DATA SYS007/1.047197551196598D0/
       IERR = 0
       R1 = 3.D0*A(1)
       IF (A(1) .NE. 0.D0) GO TO 10
          IERR = 65
          CALL UTZP11(IERR,16)
          GO TO 60
   10  CONTINUE
       R2 = A(2)/R1
       X = A(3)/R1 - R2**2
       Y = 3.D0*A(4)/R1 + 2.D0*R2**3 - 3.D0*R2*(A(3)/R1)
       Z = -2.D0*DSQRT(DABS(X))
       IF (X .NE. 0.D0 .OR. Y .NE. 0.D0) GO TO 20
          NREAL = 3
          ROOT(1) = -R2
          ROOT(2) = ROOT(1)
          ROOT(3) = ROOT(1)
          GO TO 60
   20  CONTINUE
       IF (DABS(Y)-X*Z) 30,15,40
   30  CONTINUE
       NREAL = 3
       Y = (Y/X)/Z
       Y = (2.D0/3.D0)*DATAN2(DSQRT(1.D0-Y),DSQRT(1.D0+Y))
       P = Z*DCOS(Y) - R2
       X = -Z*DCOS(Y-SYS007) - R2
       Y = -Z*DCOS(Y+SYS007) - R2
       ROOT(1) = DMIN1(P,X,Y)
       ROOT(3) = DMAX1(P,X,Y)
       ROOT(2) = -A(2)/A(1) - ROOT(1) - ROOT(3)
       GO TO 60
   40  CONTINUE
       Z=X*Z
       R1=DMAX1(DABS(Y),DABS(Z))
       Z=R1*DSQRT((Y/R1)**2-(Z/R1)*(DABS(Z)/R1))
       Z = 0.5D0*(Z + (Y/Z)*Y + (4.D0*X/Z)*X*X)
       GO TO 16
   15  Z=0
   16  NREAL = 1
       P = Y + Z
       X = DSIGN((DSQRT(0.5D0)*DSQRT(DABS(P)))**(2.D0/3.D0),P)
       P = Y - Z
       Y = DSIGN((DSQRT(0.5D0)*DSQRT(DABS(P)))**(2.D0/3.D0),P)
       Z = X + Y
       ROOT(1) = -Z - R2
       ROOT(2) = 0.5D0*Z - R2
       ROOT(3) = DSQRT(0.75D0)*DABS(X-Y)
   60  RETURN
      END
